#include <qapplication.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qpainter.h>

class Viewer :public QWidget
{
public:
  Viewer( QWidget* parent ) : QWidget( parent )
  {
    QPixmap bgImg("background.png"); // 8 bit
    buffer.resize( bgImg.size() );
    QPixmap cross( "cross.png" );

    // Alpha-blending
    QPainter painter( &buffer );
    painter.drawPixmap( 0, 0, bgImg );
    painter.drawPixmap( 0, 0, cross );

    // ? bgImg.setAlphaBuffer( false );

    setFixedSize( buffer.size() );
  }

  virtual void paintEvent ( QPaintEvent * )
  {
    bitBlt( this, 0, 0, &buffer );
  }

private:
    QPixmap buffer;
};

int main( int argc, char** argv )
{
  QApplication app( argc, argv );

  Viewer* viewer = new Viewer(0);
  app.setMainWidget( viewer );
  viewer->show();

  return app.exec();
}
