#include "busy.h"
#include <qevent.h>
#include <qapplication.h>
#include <qcursor.h>

Busy* Busy::_instance = 0;

Busy::Busy() : QObject(0), _isOn( false )
{
}

void Busy::setBusy( bool on )
{
  if ( _instance == 0 )
    _instance = new Busy();

  if( on == _instance->_isOn )
	  return;

  if ( on ) {
    qApp->installEventFilter( _instance );
    QApplication::setOverrideCursor( Qt::WaitCursor );
  }
  else {
    qApp->removeEventFilter( _instance );
    QApplication::restoreOverrideCursor();
  }

  _instance->_isOn = on;
}

bool Busy::eventFilter( QObject*, QEvent* e)
{
  if ( e->type() == QEvent::KeyPress ||
       e->type() == QEvent::KeyRelease ||
       e->type() == QEvent::MouseButtonPress ||
       e->type() == QEvent::MouseButtonRelease ||
       e->type() == QEvent::MouseButtonDblClick )
    return true;
  return false;
}
