#include <qapplication.h>
#include <qpushbutton.h>
#include <qobject.h>
#include <qapplication.h>
#include <qeventloop.h>
#include "busy.h"

#if defined Q_WS_X11
#include <unistd.h>
#elif defined Q_WS_WIN
#include <winsock.h>
#if defined WINDOWS_HACK
#include <time.h>
inline void usleep( unsigned long t )
{
    unsigned long nt = t/1000;
    _sleep( nt );
}

#elif defined BORLAND_HACK
#include <dos.h>
inline
  void usleep(unsigned long t)
  {
          unsigned long nt = t;
          _sleep( nt );
  }

#endif
#endif

class GoButton :public QPushButton
{
Q_OBJECT
public:
    GoButton( const QString& text, QWidget* parent )
        :QPushButton( text, parent ) {
        connect( this, SIGNAL( clicked() ), this, SLOT( go() ) );
    }

public slots:
    void go() {
        Busy::setBusy( true );
        static int instance = 0;
        int myInstance = instance++;
        for ( int i= 0; i<10;i++) {
            QApplication::eventLoop()->processEvents( QEventLoop::AllEvents );
            qDebug("instance=%d, i=%d", myInstance, i);
            usleep(500000);
        }
        Busy::setBusy( false );
    }
};

int main(int argc, char** argv)
{
    QApplication a( argc, argv );
    GoButton* b = new GoButton("Press Me, Please", 0);
    b->show();
    QObject::connect( qApp, SIGNAL( lastWindowClosed() ),
		      qApp, SLOT( quit() ) );
    a.exec();
}

#include "main.moc"
