#include <qapplication.h>
#include <qhbox.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlayout.h>
#include <stdlib.h>
#include "shootabug.h"

void maybeInstallDebugFilter()
{
    if ( getenv("debug") ) {
        qDebug("Press Ctrl+Shift+left mouse button to test widgets");
        qApp->installEventFilter( new ShootABug() );
    }
}


int main( int argc, char** argv ) {
    QApplication app( argc, argv );

    maybeInstallDebugFilter();
    QWidget* top = new QWidget( 0, "top" );

    QVBoxLayout* layout = new QVBoxLayout( top, 10, -1, "layout" );
    layout->setAutoAdd( true );

    new QLabel("Hello world", top, "label" );
    QPushButton* but = new QPushButton("Quit", top, "push button" );
    QObject::connect( but, SIGNAL( clicked() ), qApp, SLOT( quit() ) );
    top->show();

    QObject::connect( qApp, SIGNAL( lastWindowClosed() ),
		      qApp, SLOT( quit() ) );
    return app.exec();
}

